/********************************************************************
* Filename: ADC.c 													*
* Date: 29/06/2007 													*
* File Version: 1.00 												*
* ADC Funktionen													*
*	-Initalisierung init_ADC()										*
*	-Funktion read_ADC()											*					
* Linker File: p30f6012.gld 										*
* last modified by S.FISCHER 										*
*********************************************************************/

#include "p30f5015.h"
#include "delay.h"
#include "globalvar.h"

//-----------------------------------------------------------------------------
//ADC Initalisieren
//-----------------------------------------------------------------------------
void init_ADC(void)
{
//	ADCON3bits.ADCS = 0x05; // Conversion Time: Tad=Tcy/2*(ADCS+1)=99ns
//	ADCON1bits.SSRC = 0x07; // Trigger Source (Auto start mode)
//	ADCON3bits.SAMC = 0x02;	// Tad's zwischen der Conversion =2Tad+12Tad (aquisition Time)
//	ADCON1bits.ASAM = 1;	// enable automatic sampling
//	ADCON1bits.SIMSAM = 0;	// enable Sequential sampling ->nur 30f5015
//	ADCON2bits.CHPS = 0x03;	// 4 ADC-Kanle 

//------------------------ Fr Multiplex Betrieb--------------------
ADPCFG =0x3FFC; 	// AN2-AN13 Pins Analog input
ADCSSL = 0x3FFB;	// input Scan AN2-AN3 
ADCON1 = 0x00E0; 	// SSRC bit = 111 implies internal
					// counter ends sampling and starts
			
// ADCHS = 0x0000; 	// Connect RB0/AN0 as CH0 input ..
//ADCHS=0x0080;			
//ADCON3 =0x0F01;		// Sample time = 1Tad, Tad = internal Tcy/2
ADCON3 = 0x1F3F; 	// Sample time = 31Tad, Tad = internal 32 Tcy
//ADCON3 = 0x0181;	// Sample time = 1Tad, Tad = internal 1Tcy	-AD-Clock internal
ADCON2 = 0x040C;	//alle 4 Samples ein Interrupt, Vdd Vss fr ADC
//ADCON2 = 0x0414;	//alle 5 Samples ein Interrupt, Vdd Vss fr ADC
IEC0bits.ADIE = 1;  //ADC Interrupt enable
ADCON1bits.ADON = 1; // turn ADC ON

}

void read_ADC(void)
{
	ADCON1bits.SAMP = 1; 	// start sampling then ...
						// after 31Tad go to conversion
	while (!ADCON1bits.DONE);// conversion done?
	ADCON1bits.SAMP = 0; 	// end sampling
	
}

//void read_ADC(void)
//{
//	
//	ADCON1bits.ASAM = 1; // automatisch Samplen
////	ADCON1bits.SAMP = 0;
//    while (!ADCON1bits.DONE);// conversion done?
////	ADCON1bits.ADON = 0; // turn ADC OFF
////	while (!IFS0bits.ADIF);// conversion done?
////	ADCON1bits.ASAM = 0; // automatisch Samplen
////	delay_ms(100);
//	return; // yes then get ADC values
//	
//}


void analog_init (void) //funktioniert scant aber nur ch0
{
	// AD Init
	ADPCFG =0xC003; 		// AN2-AN13 Pins Analog input
	ADCSSL = 0x3F00;		// input Scan AN8-AN13 
	ADCON3bits.ADCS = 18; 	// 16xPLL	Tad min 300ns fr 16MHZ berechnet
	ADCON1bits.SSRC = 0x07;	// autoconvert
	ADCON3bits.SAMC = 3;	// 12TAD sample time	
							// Die Zeit, die man beim PIC16/18 warten mute, bevor man nach der
							// Kanalauswahl GO/DONE setzen konnte
	ADCON2bits.CHPS = 0;	//	scan channel 0						
	ADCON2bits.CSCNA = 1;	// scan-mode
	ADCON2bits.SMPI = 5;	// interrupt nach 6 Umsetzungen 
	ADCON2bits.VCFG = 3;	// externe Vref verwenden.						// 0 --> eine Umsetzung
						
	ADCON1bits.ADON = 1;	// A/D einschalten	
}


void analog_init2 (void)
{
	// AD Init
	ADPCFG =0xC003; 		// AN2-AN13 Pins Analog input
//	ADCSSL = 0x3F00;		// input Scan AN8-AN13 
	ADCON1bits.SIMSAM = 1;	// enable 0=simultan 1=sequential sampling 
	ADCON1bits.SSRC = 0x07;	// autoconvert
	ADCON3bits.SAMC = 12;	// 8TAD sample time for 400ksps
	ADCON2bits.CHPS = 3;	// scan channel 0 1 2 3						
	
	//ADCON2bits.CSCNA = 1;	// scan-mode
	ADCON2bits.SMPI = 0;	// interrupt nach 4 Umsetzungen 
							// 0 --> eine Umsetzung
	ADCON2bits.VCFG = 3;	// externe Vref verwenden.
	ADCON3bits.ADCS = 5; 	// Tad min 313ns fr 30MHZ berechnet ADCS=(2*Tad/Tcy)-1 //bei 45 keine aussetzer mehr 
	ADCHSbits.CH123SA = 1; 	// positive input CH1-AN3 CH2-AN4 CH3-AN5 
	ADCHSbits.CH123NA = 0;	// negative input for all vref-
	ADCHSbits.CH0SA	= 8;	// zu beginn AN8 mit CH0 scannen
	ADCHSbits.CH0NA	= 0;	// negativ CH0 input Vref-					
	IEC0bits.ADIE = 1;  	// ADC Interrupt enable
	ADCON1bits.ADON = 1;	// A/D einschalten	
}


/*****************************************************************************
* Funktion liest alle auf dem dsPICDEM vorhandenen analogen Quellen ein   		*
* und wartet, bis die Ergebnisse vorliegen.                                  *
* Vorsicht sind die eingaenge offen d.h ohne feste Potenziale wird eine Spannung 
* mitgemultiplexed!!!
* 
******************************************************************************/

void read_analog (void)
{
	IFS0bits.ADIF = 0;
	ADCON1bits.ASAM = 1;	// Umsetzungen starten	
//	while (!IFS0bits.ADIF); // warten, bis Umsetzungen fertig
//	ADCON1bits.ASAM = 0;    // Umsetzung anhalten	
		
	
}	



void adcvolt(unsigned char *buffer, unsigned int ADRES)
{
	 unsigned char adones = 0;					//reset values
	 unsigned char adtenths = 0;
	 unsigned char adhundredths = 0;
	 while (ADRES > 0x8)
	 {
	  	if(ADRES > 0x333)		//test for 1 volt or greater
		{
			adones++;			//increment 1 volt counter
			ADRES -= 0x334;			//subtract 1 volt
		}
		else if(ADRES > 0x51 && ADRES <= 0x333)		
		{
			if (adtenths < 9)
		   	{
			  adtenths++;			//increment tenths
			}
			else 
			{
			  adones++;			//tenths has rolled over
			  adtenths = 0;			//so increment ones and reset tenths
			}
			ADRES -=0x52;
		}
		else if(ADRES > 0x8 && ADRES <= 0x51)		
		{
			if (adhundredths < 9)
			{
				adhundredths++;		//increment hundreths
			}
			else 
			{
				
				adhundredths = 0;	//reset hundredths
				if (adtenths < 9)
		   		{
			  		adtenths++;			//and increment tenths
				}
				else 
				{
			 	 	adones++;			//unless tenths has rolled over
			  		adtenths = 0;			//so increment ones and reset tenths
				}
			}
			ADRES -= 0x9;
		}

		
		
	}
	buffer[0] = adones + 0x30;
	buffer[1] = '.';
	buffer[2] = adtenths + 0x30;
	buffer[3] = adhundredths + 0x30;
	buffer[4] = 'V';
	buffer[5] = ' ';
	buffer[6] = '\0';	
}

// Umwandlung eines positiven int-Werts in einen ASCII-String mit "digits" Stellen.
// Werden mehr Stellen angegeben, als der Wert erfordert, erfolgt die Ausgabe mit
// fhrenden Nullen.
void int_2_ascii (unsigned char *buffer, long int wert,unsigned char digits)
{	
	long int n = 1;
	unsigned char i;

	for (i=1; i<digits; ++i)
	{
		n *= 10;	
	}

	for (i=0; i<digits;++i)
	{
		buffer[i] = 48;			// ASCII: 0
  		while (wert >= n)
    	{
        	wert -= n;
        	++buffer[i];
    	}        
		n /= 10;
	}
	
	buffer[digits] = '\0';	// Endekennung String	
}

double adc_2_volt (unsigned int adc_wert)
{
	return ((double)(adc_wert*5)/4095.0);	
}

void int_2_volt (unsigned char *buffer,float wert,float mul)
{
int b0,b1,b2,b3,b4,b5,b6;
wert=wert*mul ; //15 entspricht 15360		
				//5			"	5120
				//3.3		"	3379	

int_2_ascii(buffer,wert,5);
if (wert<10000) //kein 10er also stelle weglassen
{
buffer[0]=' ';
}


buffer[5]=buffer[4];
buffer[4]=buffer[3];
buffer[3]=buffer[2];

	//buffer 3 bis 5 entspricht den 3 nachkommastellen

buffer[2]='.';
buffer[6]='V';
buffer[7]='\0';



b0=buffer[0];
b1=buffer[1];
b2=buffer[2];
b3=buffer[3];
b4=buffer[4];
b5=buffer[5];
b6=buffer[6];

}
