#include "dsp.h"
#include "p30f5015.h"

tPID dc150PID;
fractional abcCoefficient[3] __attribute__ ((section (".xbss, bss, xmemory")));
fractional controlHistory[3] __attribute__ ((section (".ybss, bss, ymemory")));

fractional kCoeffs[] = {0,0,0};  //definition {kp,ki,kd}


void setupPID (void)
{

        dc150PID.abcCoefficients = &abcCoefficient[0];    /*Set up pointer to derived coefficients */
        dc150PID.controlHistory = &controlHistory[0];     /*Set up pointer to controller history samples */
        PIDInit(&dc150PID);                               /*Clear the controler history and the controller output */
		kCoeffs[0] = Q15(0.7); 	//kp
		kCoeffs[1] = Q15(0.2); 	//ki
		kCoeffs[2] = Q15(0.07);	//kd
        PIDCoeffCalc(&kCoeffs[0], &dc150PID);             /*Derive the a,b, & c coefficients from the Kp, Ki & Kd */
		
		


}

int calcPID (int act_value,int des_value)
{
		dc150PID.controlReference = des_value ;           /*Set the Reference Input for your controller */
        dc150PID.measuredOutput = act_value ;            /*Typically the measuredOutput variable is a plant response*/
		PID(&dc150PID);
		return dc150PID.controlOutput;
	
}


