
/********************************************************************
* Filename: SPI.c 													*
* Date: 29/06/2007 													*
* File Version: 1.00 												*
* SPI Funktionen													*
*	-Initalisierung init_SPI()										*
*	-Funktion transmitt_SPI()											*					
* Linker File: p30f6012.gld 										*
* last modified by S.FISCHER 										*
*********************************************************************/





#include "p30f5015.h"
#define bit0(x) (x&1)

void init_SPI(void)
{
	
	SPI2CONbits.PPRE = 1;	//primrer Prescaler auf 1:1 16xPLL
	SPI2CONbits.SPRE = 7;	//sekundrer Prescaler auf 1:1 fr 30Mhz CLOCK 
	
	SPI2CONbits.SPIFSD = 0;	// Master SSx=Output
	SPI2CONbits.MODE16 = 1;	// SPI 16Bit Mode
	SPI2CONbits.MSTEN = 1;	// SPI Master Mode
	SPI2CONbits.SMP = 0;	// input Data wird in der mitte der bertragung gesampled	
	SPI2CONbits.CKE = 1;	// active bei steigende Flanke
	SPI2CONbits.CKP = 0;	// Clock polaritt High=High
	SPI2CONbits.SSEN = 0;	// SSx PIN low bei bertragung
	SPI2CONbits.FRMEN = 0;	// Framed SPI Support
	SPI2STATbits.SPIEN = 1;	// Enable SPI
	IFS1bits.SPI2IF=0; // Interruptflag lschen
//	IEC1bits.SPI2IE=1; // Interrupt enablen 
	PORTGbits.RG9 = 1; // SSx High Schalten 
}

unsigned int transmitt_SPI(unsigned int data)
{
//	while (SPI2STATbits.SPITBF);	// Warten bis Buffer leer (mte hier redundant sein, 
//	asm volatile("DISI #0x3fff");//disable all Interrupts 
								// da auf SPIRBF gewartet wird 
	PORTGbits.RG9 = 0; // SSx Low Schalten fr starten der bertragung
	asm("nop");
	asm("nop");
	asm("nop");
	//LATDbits.LATD6 = 1;
	SPI2BUF = data;					// Daten ausgeben


	while (!SPI2STATbits.SPIRBF);	// Warten, bis bertragung abgeschlossen ist 	
	asm("nop");
	asm("nop");
	asm("nop");
	PORTGbits.RG9 = 1; // SSx High Schalten ende der bertragung
//	asm volatile("DISI #0x0000");//enable all Interrupts 
	return (SPI2BUF);				// Empfangene Daten auslesen, auch ntig wenn nur gesendet 
									// werden soll !!!
}


unsigned int parity_check (unsigned int data) 
{
 
int p = 0;

for ( ; data != 0; data >>= 1)
	p ^= bit0 (data);
return p;

}

unsigned int data_form (unsigned int data,char select)
{

	//Startbit setzen
	if (select==0)         
	data = data | 0x8000; // Startbit=1 Parittsbit=0 und select=00->Freq  
	else
	data = data |0x9000;  // Startbit=1 Parittsbit=0 und select=01->Phase   	
	
	//parittsbit ermitteln und gegebenenfalls hinzufgen
	if(parity_check(data))
	{
		if (select==0)         
		data = data | 0xC000; // Startbit=1 Parittsbit=1 und select=00->Freq  
		else
		data = data |0xD000;  // Startbit=1 Parittsbit=1 und select=01->Phase   	
	}

return data;
 

}
