#include "p30f5015.h"
#include "delay.h"


void delay_ms (unsigned int ms) 
{
	// Fehlerbetrachtung PR5=7373
	// Grundfehler: ca. 14 Cycles (inlusive Funktionsaufruf und Rcksprung) --> 1.90s	
	//              Worst Case: 1ms, Fehler +0.19%	
	// integraler Fehler: +27.1ns pro ms (Quarztakt dsPICDEM 1.1 fr USART optimiert)
	
	// Gesamtfehler: 1.90s + ms*27.1ns  
    //    1ms :  1.9271s (+0.193%)
    //   10ms :  2.171s  (+0.022%) 
    //  100ms :  4.610s  (+0.005%)
    // 1000ms : 29.000s  (+0.003%)    

	// Fehlerbetrachtung PR5=7372    
    // Grundfehler gleich
    // integraler Fehler: -108,5ns pro ms
    
    // Gesamtfehler: 1.90s - ms*108.5ns
    //    1ms :  1.792s  (+0.179%)
    //   10ms :  0.815s  (+0.008%) 
    //  100ms : -8.950s  (-0.009%)
    // 1000ms : -106.6s  (-0.011%)
    
	
	      
	// Timer 5 kann auerhalb der delay Funktion frei verwendet werden
	// (auer in Interrupt-Routinen)	
	// Setzen von T5CON=0 und PR5 unntig, wenn Timer 5 nur fr delay verwendet wird
	T5CON = 0;				// Prescaler 1, Timer 5 aus
	
	
				// 7372 * 135.63... ns = 1ms - 108.5ns


	PR5 = 29491;

	TMR5 = 0;					
	IFS1bits.T5IF = 0;
	T5CONbits.TON = 1;		// Timer starten
	
	do {
		while (!IFS1bits.T5IF); 
		IFS1bits.T5IF = 0;
		--ms;
	} while (ms > 0);

	T5CONbits.TON = 0;		// Timer anhalten	
}
