/********************************************************************
* Filename: main.c 													*
* Date: 18/06/2007 													*
* File Version: 1.00 												*
* Tools used: MPLAB -> 7.60 										*
* 					Compiler -> 3.00 								*
* 					Assembler -> 3.00 								*
* 					Linker -> 3.00 									*
* Linker File: p30f6012.gld 										*
* last modified by S.FISCHER 06.06.07								*
*********************************************************************/
#include "p30f5015.h"
#include "stdio.h"
#include "ADC.h"
#include "SPI.h"
#include "USART.h"
#include "Config_bits.h"
#include "delay.h"
#include "input_capture.h"
#include "temp.h"
#include "globalvar.h"
#include "error_handle.h"
#include "InCap.h"
#include "watchdog.h"
#include "adc10.h"
//#include "dsp.h"


//Program Specific Constants
#define FCY 7372800 //Instruction cycle rate (Osc x PLL / 4)


//====================================Variablen fr main=====================

char mode=0;


//--------------------------------------MAIN----------------------------------------------

int main(void)
{
 


//---------------------------------------------I/O PORT Konfiguration 

	TRISB=0x3F3B;	//Analog Inputs,Vref, and LEDs,TP403=output,EMU=00
	TRISC=0x0000;	//CAN-BUS and Oscillator
	TRISD=0x0F00;	//INPUT Captures & PARALLEL PORT
	TRISE=0x0000;   //set PWM0-PWM7 as output
	TRISF=0x0035;	//Switches and UART 
	TRISG=0x0080;	//Set SS2x=out SDI2=in SDO2=out SCK2=out and I2C-BUS off 	


	LATB = 0xC000; //Initialize LED pin data to off state
	
//------------------------------------Watchdog--------------------------------------
//	RCONbits.SWDTEN=1;
	if(RCONbits.WDTO==1) watchdog(); //wurde der Reset durch den watchdog erzeugt ? 
	RCON=0x0000;//Lschen des RCON Registers damit der Reset status beim nchsten Reset aktualisiert wird.
	error_handle();
	

//---------------------------------------------Timer initalisierung 
	
	//-------------------Timer 1 fr Terminal Steuerung (fr bessere lesbarkeit)
	T1CON = 0; 			//Turn off Timer1 and clear settings
	TMR1 = 0; 			//Start Timer1 at zero
	PR1 = 59180	; 		//Set period register value for 500ms second
	T1CON = 0x8030; 	//Turn on Timer1 with 1:256 prescaler
	IEC0bits.T1IE=1; 	//Interrupt enable;	
	
	//-------------------Timer 2 fr frequenz messung
	T2CON = 0; 			//Turn off Timer2 and clear settings
	TMR2 = 0; 			//Start Timer2 at zero
//	PR2 = 0xffff; 		//>100ms 
//	T2CON = 0x8000; 	//Turn on Timer1 with 1:1 prescaler
	IEC0bits.T2IE=1; 	//Interrupt enable;			

	//-------------------Timer 3 fr RD0 Syncronistation 
  	T3CON = 0; 			//Turn off Timer3 and clear settings
	TMR3 = 0; 			//Start Timer3 at zero
//	T3CON = 0x8000;   	//start timer 1:1
//	PR3 = 
	IEC0bits.T3IE=1; 	//Interrupt enable;	
	
	//------------------Timer 4 fr SPI Zeit zwischen daten Paketen 
    T4CON = 0; 			//Turn off Timer1 and clear settings
	TMR4 = 0; 			//Start Timer4 at zero
	T4CON = 0x8000;   	//start timer
	PR4 = 800; 			//250us zwischen den datenpaketen
	IEC1bits.T4IE=1; 	//Interrupt enable;	
	
//-------- Pheripherie initialisieren------------------------------------------ 
	
	
	
	//LATBbits.LATB14 = 0; //Turn on LED2 funktionstest	
	usart1_init();		//usart1 initalisieren siehe usart.c
	analog_init2(); 		//AD Initalisieren
	init_IC(); 			//Input capture Initalisieren
	init_SPI(); 		//SPI Schnittstelle initalisieren
    
	INTCON2bits.INT4EP=1; //External interuppt INT4 bei fallender Flanke von NULL
	IEC2bits.INT4IE=1;
	IFS2bits.INT4IF=0; //Intflag anfangs lschen
	
	CNPU2bits.CN18PUE=1; //Interne Pullups fr Schalter einschalten.
	CNPU2bits.CN17PUE=1;
	
	LATBbits.LATB15 = 0; //Turn on LED1 funktionstest

//----------------------------------------------Interrupt Prioritten

	IPC0bits.T1IP = 1; //Timer 1
	IPC1bits.T2IP = 3; //Timer 2
//	IPC1bits.T3IP = 7; //Timer 3
	IPC9bits.INT4IP = 6; //INT4 fr fallende flanke NULL
	IPC5bits.T4IP = 2; //Timer 4
	IPC7bits.IC3IP= 5;  //Input CApture 
	IPC2bits.U1TXIP=1;  //Uart TX 
	IPC2bits.ADIP=6;	//AD priority 

//----------------------------------------------------------------------
/* TESTWIESE */

//		putch('\f');
//		sprintf (buffer,"Menu\v");
//		text_out(buffer);
//		putch('\r');
//		sprintf (buffer,"press v for Voltage\v");
//
//----------------------------------------------------------------------
//-----------------------------AD-Wandler Starten
//	read_analog(); 

//-------------------------------Loop forever------------------------------
while(1) 
{
 	T2CON = 0x8000;//Timer fr frequenzmessung starten;
	error_handle();



// ------------------------------UART Empfangsbuffer auswerten
	if (uart_empf=='f')
		mode=1;
	if (uart_empf=='v')
		mode=0;
	if (uart_empf=='t')
		{mode=3;U1STAbits.UTXEN = 1;}	// enable TX fr weitere tabellen
	if (uart_empf=='e')
		mode=2;
	if (uart_empf==0x1b) //0x1B=ESC
		mode=4;
	if (uart_empf=='r')
		mode=5;
									//SPI-Daten ndern 
	if (uart_empf=='8')
		spi_freq+=1;
		if(spi_freq>4096) spi_freq=4096;
	if (uart_empf=='2')
		spi_freq-=1;
		if(spi_freq<0) spi_freq=0;
	if (uart_empf=='9')
		spi_phase+=1;
		if(spi_phase>4096) spi_phase=4096;
	if (uart_empf=='3')
		spi_phase-=1;
		if(spi_phase<0) spi_phase=0;
	uart_empf=0;
//----------------------------------SPI DATEN Aufbereitung  

	spi_send_freq=data_form(spi_freq,0);	//controlword fr freq bestimmen
	spi_send_phase=data_form(spi_phase,1); //controlword fr phase bestimmen

//asm volatile("DISI #0x3fff");//disable all Interrupts 

	if(PORTF&0x0020)  //wenn  der schalter SW402 an 
	{
	ADCON1bits.ADON = 0;
	IPC9bits.INT4IP = 7; //INT4 fr fallende flanke NULL
	IPC7bits.IC3IP= 7;
	IPC2bits.ADIP=5;	//AD priority 
	}
	else 
	{	
	ADCON1bits.ADON = 1;
	IPC9bits.INT4IP = 5; //INT4 fr fallende flanke NULL
	IPC7bits.IC3IP= 5;
	IPC2bits.ADIP=6;	//AD priority 
	}

//------------------------------MODUS Statemachine---------------------------------------------------

switch (mode)
{
case 0: 								//----------->MODE0: ADC Ausgeben temperatur u. Voltmessung
	{

U1STAbits.UTXEN = 1;	// enable TX
								//ADC Scan starten.
if (monitor_on)
	{
		
		clear_buffer(buffer);
		
		putch('\n');
		putch('\f');
		int_2_ascii(buffer,I_ist,5);				//I_ist
		text_out(buffer);
		putch('\t');
		int_2_ascii(buffer,I_pk,5);					//I_pk
		text_out(buffer);
		putch('\t');
		int_2_ascii(buffer,U_zk,5);					//U_zk
		text_out(buffer);
		putch('\t');


//		int_2_volt(buffer,ADCBUF0,10);					//Ausgabe der ADC Werte
//		int_2_ascii(buffer,ADCBUF0,5);
		int_2_volt(buffer,ADarray[0],9.7);
							//Vcc=2.5V
		text_out(buffer);

		putch('\t');

//		clear_buffer(buffer);						
//		int_2_volt(buffer, ADCBUF1,4.8);					//+3.3V
//		int_2_ascii(buffer,ADCBUF1,5);
		int_2_volt(buffer,ADarray[1],4.8);					//3.3V entspricht 675digits =>675*4.88=3300
		text_out(buffer);
		
		
 		putch('\t');
//		clear_buffer(buffer);
//		int_2_volt (buffer, ADCBUF2,19.5);					//+15V
//		int_2_ascii(buffer,ADCBUF2,5);
		int_2_volt(buffer,ADarray[2],19.2);					//15V entspricht 768digits =>768*19.5=15000
		text_out(buffer);									//19.2 wegen 0.3 offset
				
		putch('\t');
//		clear_buffer(buffer);
//		int_2_volt(buffer,ADCBUF3,19.5);					//Vin
//		int_2_ascii(buffer,ADCBUF3,5);
		int_2_volt(buffer,ADarray[3],19.2);					//18V entspricht 921digits =>921*19.54=18000
		text_out(buffer);									//19.2 wegen 0.3 offset	
		
		putch('\t');
//		clear_buffer(buffer);
//		int_2_temp2(buffer,ADCBUF4);					//KK_T
//		int_2_ascii(buffer,ADCBUF4,5);
		int_2_temp2(buffer,ADarray[4]);
		text_out(buffer);
		
		putch('\t');
//		clear_buffer(buffer);
//		int_2_temp2(buffer,ADCBUF5);					//EX_T
//		int_2_ascii(buffer,ADCBUF5,5);
		int_2_temp2(buffer,ADarray[5]);
		text_out(buffer);	

		putch('\t');
//		clear_buffer(buffer);
//		int_2_temp2(buffer,ADCBUF5);					//AD->KK_T
//		int_2_ascii(buffer,ADCBUF5,5);
		int_2_ascii(buffer,ADarray[4],5);
		text_out(buffer);	
		putch('\r');
		monitor_on=0;
	}
	
		break;			
	}
case 1:									//--------->MODE1: Freq messen
	{
	   
//		while(!IFS0bits.T1IF){} //Wait for T1 Interrupt Flag
U1STAbits.UTXEN = 1;	// enable TX
////		IFS0bits.T1IF = 0; //Clear AD flag for next period
//while(!int_flag); /* wait here till first capture event */
//	int_flag = 0;
//while(!int_flag); /* wait here till next capture event */
///* calculate time count between two capture events */
//	IC_counts = timer_second_edge - timer_first_edge;
//	Interrupt_Count=0;
//	int_flag = 0;
//

if (monitor_on)
	{

		putch('\f');
		U1STAbits.UTXEN = 1;	// enable TX

		clear_buffer(buffer); 
		int_2_ascii(buffer,IC_counts,10);
		text_out(buffer);
		putch('\t');
		int_2_khz(buffer,IC_counts);
		text_out(buffer);
		putch('\t');
		int_2_ascii(buffer,timer_first_edge,10);
		text_out(buffer);
		putch('\t');
		int_2_ascii(buffer,timer_second_edge,10);
		text_out(buffer);
		putch('\r');			
		monitor_on=0;
	}
		break;
	}
case 2:									//---------->MODE2: SPI bertragung
	{
		
	
//		while(!IFS0bits.T1IF){} //Wait for T1 Interrupt Flag
		U1STAbits.UTXEN = 1;	// enable TX
//		IFS0bits.T1IF = 0; //Clear AD flag for next period
	if (monitor_on)
	{	
		putch('\f');
		clear_buffer(buffer);
		int_2_ascii(buffer,spi_err,3);	
		text_out(buffer);
		putch('\t');	
   		
		
		int_2_ascii(buffer,spi_freq,6);
		text_out(buffer);
		putch('\t');
		int_2_ascii(buffer,spi_phase,6);
		text_out(buffer);
		putch('\t');
		int_2_ascii(buffer,spi_empf_freq,6);
		text_out(buffer);
		putch('\t');
		int_2_ascii(buffer,spi_empf_phase,6);
		text_out(buffer);
		putch('\r');
		monitor_on=0;
	}

	break;
	}

case 3:									//---------->MODE3: Tabellenausgabe
	{
	
		ADCptr = &I_pktmp;
		I_istptr =&I_ist;	
		tab_out(buffer,ADCptr,I_istptr,1000);
		
		break;
	}
case 4:
{		
//		while(!IFS0bits.T1IF){} //Wait for T1 Interrupt Flag
//		U1STAbits.UTXEN = 1;	// enable TX
//		IFS0bits.T1IF = 0; //Clear AD flag for next period
	if(monitor_on)
	{
		putch('\f');
		sprintf (buffer,"Menu\v");
		text_out(buffer);
		putch('\r');
		sprintf (buffer,"press v for Voltage\v");
		text_out(buffer);
		putch('\r');
		sprintf (buffer,"press f for Frequency\v");
		text_out(buffer);
		putch('\r');
		sprintf (buffer,"press e for SPI\v");
		text_out(buffer);
		putch('\r');
		sprintf (buffer,"press t for table\v");
		text_out(buffer);
		putch('\r');
		sprintf (buffer,"press r for RD\v");
		text_out(buffer);
		putch('\r');
		monitor_on=0;
//	U1STAbits.UTXEN = 0;
	}
		break;
}
case 5:
{


//if (rd0_flag)
//{

//read_analog();
	if(monitor_on)
	{		

		putch('\f');
		int_2_ascii(buffer,I_ist,5);				//I_ist
		text_out(buffer);
		putch('\t');
		int_2_ascii(buffer,I_pk,5);					//I_pk
		text_out(buffer);

		putch('\r');
	monitor_on=0;
	}
//rd0_flag=0;
//
//}
break;
}	


default:
	{
		mode=0;
		break;
	}
} //end switch
//-------------------------------------------------------------------------------

//error_handle();
asm ("CLRWDT"); //alle 128ms muss der watchdog zurckgesetzt werden, sonst RESET


} //end while(1)	

} //End of main()




//=============================================================
// INTERRUPT SERVICE ROUTINEN
//=============================================================

//------------------------------Timer Interrupts--------------------------------
void __attribute__((interrupt, no_auto_psv))_T1Interrupt (void)
{
//	IC_counts=BUFF0;
//	BUFF0=0;
	monitor_on=1;
	IFS0bits.T1IF=0;	
}


void __attribute__((interrupt, no_auto_psv))_T2Interrupt (void)
{

	IFS0bits.T2IF=0;	
}
void __attribute__((interrupt, no_auto_psv))_INT4Interrupt (void)
{
	if(PORTF&0x0010)  //wenn der schalter SW402 an 	
	{
	asm volatile("DISI #0x4");//disable all Interrupts 
	LATDbits.LATD0 = 1;	//Pin RD0 High zum entladen des C's
 /*  	asm ("nop"); //ca. 500ns verz.
	asm ("nop");
    asm ("nop");
    asm ("nop");
    asm ("nop");
    asm ("nop");
    asm ("nop");
    asm ("nop");*/

   
	LATDbits.LATD0 = 0;	
	}



	PR3 = (IC_counts>>2); 			//Set period register value for T/2 = (IC_counts/2)-offset
	TMR3=0;								//Timer 3 zurcksetzen
	T3CON = 0x8000; 					//Turn on Timer3 with 1:1 prescaler
		
	IFS2bits.INT4IF=0;	
}

void __attribute__((interrupt, no_auto_psv))_T3Interrupt (void)
{
read_ADC();
T3CON = 0x0000;  //Stop Timer3 
I_pk=I_pktmp; //immer nach ablauf von T3 wird der ADCwert fr I_pk bernommen 
IFS0bits.T3IF=0;
}


void __attribute__((interrupt, no_auto_psv))_T4Interrupt (void)
{

	PORTGbits.RG9 = 0; // SSx Low Schalten fr starten der bertragung
	if(!second)
			 
		SPI2BUF = spi_send_freq;	//bei jedem ersten T4 Interrupt freq senden
		
	else
		
		SPI2BUF = spi_send_phase;	//bei jedem zweiten T4 Interrupt phase senden 
		
	IFS1bits.T4IF=0;	
}

//------------------------------------Input Capture Interrupts ------------------

void __attribute__((interrupt, no_auto_psv))_IC3Interrupt (void)
{

	//	IFS0bits.T3IF=0; //Timer3 Interrupt Auslsen 
	if(PORTF&0x0010)  //wenn  der schalter SW402 an 
		{
	asm volatile("DISI #0x4");//disable all Interrupts 
		LATDbits.LATD0 = 1;	//Pin RD0 High zum entladen des C's
/*		asm ("nop"); //ca. 500ns verz.
		asm ("nop");
    	asm ("nop");
    	asm ("nop");
    	asm ("nop");
    	asm ("nop");
    	asm ("nop");
    	asm ("nop");*/
	
		LATDbits.LATD0 = 0;	//Pin RD0 High zum entladen des C's
		}
			Interrupt_Count++;            //verwendung von dspic Library da einfaches auslesen von IC3BUF Schwierigkeiten bereitete  
		if(Interrupt_Count == 1)			//libp30F5015-coff muss eingebunden werden 	
			ReadCapture3(&timer_first_edge);
		else //if(Interrupt_Count == 2)
			{
				ReadCapture3(&timer_second_edge);
				TMR2=0;
				IC_counts = timer_second_edge - timer_first_edge;
				Interrupt_Count=0;
			}

	//	int_flag = 1;
		
	
//		T2CON=0x8000;  // bei erster Flanke wird der Timer2 gestartet, 1:1 prescaler
		//	BUFF1=IC3BUF;
		//	BUFF2=IC3BUF;
		//	BUFF3=IC3BUF;

	//	BUFF0=IC3BUF; //IC ereignisse zwischenspeichern bzw. FIFO auslesen	 
	//	IC_counts =  BUFF0; //+BUFF1+BUFF2+BUFF3; //T+2T+3T+4T=10T 

	//	BUFF0++;		
	
			
		PR3 = (IC_counts>>2); 			//Set period register value for T/2 = (IC_counts/2)-offset
		TMR3=0;								//Timer 3 zurcksetzen
		T3CON = 0x8000; 					//Turn on Timer3 with 1:1 prescaler
		
		
		IFS1bits.IC3IF=0;	
			

}
//-----------------------AD-Interrupt----------------------------------------------

void __attribute__((interrupt, no_auto_psv))_ADCInterrupt (void)
{
	
	//Global benutzte variablen zaehler I_ist,I_pk,U_zk, ADarray[]
	
//	ADarray[zaehler]=ADCBUF0; //ergebnisse auslesen
//	I_ist=ADCBUF1;	
//	I_pktmp=ADCBUF2;
//	U_zk=ADCBUF3;
//	ADCHSbits.CH0SA++;	//AD Mux erhhen
//	zaehler++;
//
//	if(zaehler>5)//wenn Mux auf letzter pos wieder von vorn
//			{
//			ADCHSbits.CH0SA=8;	
//			zaehler=0;
//			}
	ADarray[zaehler]=(*(&ADCBUF0)); //ergebnisse auslesen (mit pointern hhere samplerate mglich wie direktes auslesen von ADCBUF) 
	I_ist=(*(&ADCBUF1));	
	I_pktmp=(*(&ADCBUF2));
	U_zk=(*(&ADCBUF3));
	ADCHSbits.CH0SA++;	//AD Mux erhhen
	zaehler++;
	LATFbits.LATF6 = 1;	//Abtastzeitpunkt sichtbar machen an TP404
	LATFbits.LATF6 = 0;	


	if(zaehler>5)//wenn Mux auf letzter pos wieder von vorn
			{
			ADCHSbits.CH0SA=8;	
			zaehler=0;
			}
	IFS0bits.ADIF=0;	
}


//---------------------UART Interrupts-----------------------------------------------

void __attribute__((interrupt, no_auto_psv))_U1TXInterrupt (void)
{

	IFS0bits.U1TXIF = 0;	// delete Interrupt flag	
	
}


void __attribute__((interrupt, no_auto_psv))_U1RXInterrupt (void)
{
	
	IFS0bits.U1RXIF = 0; //Interrupt Flag lschen
 	uart_empf=U1RXREG;   

//	while (U1STAbits.UTXBF);	
//	U1TXREG = U1RXREG;			//Echo
}
//
//
////
////void __attribute__((interrupt, no_auto_psv))_U2TXInterrupt (void)
////{
////	IFS1bits.U2TXIF = 0;	// delete Interrupt flag	
////}
////
////
//void __attribute__((interrupt, no_auto_psv))_U2RXInterrupt (void)
//{
//
//	IFS1bits.U2RXIF = 0; 	
//	while (U2STAbits.UTXBF);	
//
//}
//-------------------------------SPI-Interrupt---------------------
void __attribute__((interrupt, no_auto_psv))_SPI2Interrupt (void)
{

	if(!second)
		{
		spi_empf_freq=SPI2BUF; //empfangen freq status
		PORTGbits.RG9 = 1; // SSx High Schalten ende der bertragung
		second=1;
		}
	else
		{
		spi_empf_phase=SPI2BUF; //empfangen phase status
		PORTGbits.RG9 = 1; // SSx High Schalten ende der bertragung
		second=0;
	
		}

	if (spi_empf_freq&0x8000&&!parity_check(spi_empf_freq)) //Wenn startbit empfangen und paritt stimmt =gltige Daten 
			{ 
			LATDbits.LATD5 = 1; //Turn on LED1 funktionstest
			spi_empf_freq=spi_empf_freq&0x0FFF; //Startbit und paritt und select Ausmaskieren
			if(spi_empf_freq>=1)spi_err++;	//Wenn=1 Fehler wert hochzhlen 
		
			if(spi_err>64) spi_err=0; //maximal 64 Fehler werden gezhlt dann wieder von vorn 
			}

	if (spi_empf_phase&0x8000&&!parity_check(spi_empf_phase)) //Wenn startbit empfangen und paritt stimmt =gltige Daten 
			{ 
			spi_empf_phase=spi_empf_phase&0x0FFF; //Startbit und paritt und select Ausmaskieren
			if(spi_empf_phase>=1)	spi_err++;	//Wenn=1 Fehler wert hochzhlen 
		
			if(spi_err>64) spi_err=0; //maximal 64 Fehler werden gezhlt dann wieder von vorn 
			}

	IFS1bits.SPI2IF = 0; 	
	
}

//=============================================================================
//Error traps
//-----------------------------------------------------------------------------
//Oscillator Fail Error trap routine
void __attribute__((interrupt, no_auto_psv))_ISR _OscillatorFail(void)
{
	LATBbits.LATB14 = 0;
	error_type=TRAP_ERROR; 
	error_handle();
//while(1); //Wait forever
}
//-----------------------------------------------------------------------------
//Address Error trap routine
void __attribute__((interrupt, no_auto_psv))_ISR _AddressError(void)
{
LATBbits.LATB14 = 0; 
error_type=TRAP_ERROR;
error_handle();	
//while(1); //Wait forever
}
//-----------------------------------------------------------------------------
//Stack Error trap routine
void __attribute__((interrupt, no_auto_psv))_ISR _StackError(void)
{
LATBbits.LATB14 = 0; 
error_type=TRAP_ERROR;
error_handle();
//while(1); //Wait forever
}
//-----------------------------------------------------------------------------
//Math (Arithmetic) Error trap routine
void __attribute__((interrupt, no_auto_psv))_ISR _MathError(void)
{
LATBbits.LATB14 = 0; 
error_type=TRAP_ERROR;
error_handle();
//while(1); //Wait forever
}
